您的位置:首页 > 其它

leetcode 292. Nim Game(拿石子游戏)

2016-02-24 16:22 621 查看

leetcode 292. Nim Game(拿石子游戏)

You are playing the following Nim Game with your friend: There is a heap of stones on the table, each time one of you take turns to remove 1 to 3 stones. The one who removes the last stone will be the winner. You will take the first turn to remove the stones.

Both of you are very clever and have optimal strategies for the game. Write a function to determine whether you can win the game given the number of stones in the heap.

For example, if there are 4 stones in the heap, then you will never win the game: no matter 1, 2, or 3 stones you remove, the last stone will always be removed by your friend.

复杂度

时间:O(1)

空间:O(1)

思路

1,假设自己后走,要保证每轮自己和对方取得的数量和都是4,能不能赢取决于石子个数, 是4的倍数时,则自己稳赢;

2,假设自己先走,则拿走n除4的余数个石子,这样不管如何最后都会剩4个下来,则自己稳赢,但是如果一开始就是4 的倍数的话,则就输了。

3,总结来说,如果双方一样聪明,则采取的策略都是一样的。即能不能赢取决于先走还是后走,以及石子的个数。

赢的条件是:先走的话,石子一定不能是4的倍数;后走的话,石子要是4的倍数。

4,因为本题中自己是先走的,所以当石子的个数不是4的倍数的时候能赢,即n%4!=0

代码块

public  class Solution
{
public boolean canWinNim(int n)
{
return n%4!=0;
}
}
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: